Index: branches/FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Algorithms/LocalAnalysis.cs
===================================================================
--- branches/FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Algorithms/LocalAnalysis.cs	(revision 8083)
+++ branches/FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Algorithms/LocalAnalysis.cs	(revision 8172)
@@ -56,9 +56,9 @@
       get { return (ValueParameter<BoolValue>)Parameters["SetSeedRandomly"]; }
     }
-    public ConstrainedValueParameter<IManipulator> MutatorParameter {
-      get { return (ConstrainedValueParameter<IManipulator>)Parameters["Mutator"]; }
-    }
-    public ConstrainedValueParameter<ISelector> SelectorParameter {
-      get { return (ConstrainedValueParameter<ISelector>)Parameters["Selector"]; }
+    public IConstrainedValueParameter<IManipulator> MutatorParameter {
+      get { return (IConstrainedValueParameter<IManipulator>)Parameters["Mutator"]; }
+    }
+    public IConstrainedValueParameter<ISelector> SelectorParameter {
+      get { return (IConstrainedValueParameter<ISelector>)Parameters["Selector"]; }
     }
     private ValueParameter<IntValue> MaximumIterationsParameter {
Index: branches/FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Algorithms/RepeatedLocalAnalysis.cs
===================================================================
--- branches/FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Algorithms/RepeatedLocalAnalysis.cs	(revision 8083)
+++ branches/FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Algorithms/RepeatedLocalAnalysis.cs	(revision 8172)
@@ -58,9 +58,9 @@
       get { return (ValueParameter<BoolValue>)Parameters["SetSeedRandomly"]; }
     }
-    public ConstrainedValueParameter<IManipulator> MutatorParameter {
-      get { return (ConstrainedValueParameter<IManipulator>)Parameters["Mutator"]; }
-    }
-    public ConstrainedValueParameter<ISelector> SelectorParameter {
-      get { return (ConstrainedValueParameter<ISelector>)Parameters["Selector"]; }
+    public IConstrainedValueParameter<IManipulator> MutatorParameter {
+      get { return (IConstrainedValueParameter<IManipulator>)Parameters["Mutator"]; }
+    }
+    public IConstrainedValueParameter<ISelector> SelectorParameter {
+      get { return (IConstrainedValueParameter<ISelector>)Parameters["Selector"]; }
     }
     private ValueParameter<IntValue> MaximumIterationsParameter {
@@ -162,5 +162,5 @@
       laMainLoop.RandomParameter.ActualName = RandomCreator.RandomParameter.ActualName;
       laMainLoop.ResultsParameter.ActualName = "Results";
-      laMainLoop.AnalyzerParameter.ActualName = AnalyzerParameter.Name;      
+      laMainLoop.AnalyzerParameter.ActualName = AnalyzerParameter.Name;
 
       qualityAnalyzer = new BestAverageWorstQualityAnalyzer();
Index: branches/FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/BoxChart/BoxChartCreator.cs
===================================================================
--- branches/FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/BoxChart/BoxChartCreator.cs	(revision 8083)
+++ branches/FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/BoxChart/BoxChartCreator.cs	(revision 8172)
@@ -2,8 +2,7 @@
 using System.Collections.Generic;
 using System.Drawing;
-using System.Drawing.Drawing2D;
+using System.Drawing.Imaging;
 using System.IO;
 using System.Linq;
-using System.Text;
 using HeuristicLab.Collections;
 using HeuristicLab.Common;
@@ -14,5 +13,4 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using ICSharpCode.SharpZipLib.Zip;
-using System.Drawing.Imaging;
 
 namespace HeuristicLab.Analysis.FitnessLandscape.BoxCharts {
@@ -35,12 +33,12 @@
     }
     public ValueParameter<IntValue> PaddingParameter {
-      get { return (ValueParameter<IntValue>) Parameters["Padding"]; }
+      get { return (ValueParameter<IntValue>)Parameters["Padding"]; }
     }
     public ValueParameter<StringValue> ZipFileNameParameter {
-      get { return (ValueParameter<StringValue>) Parameters["ZipFileName"]; }
-    } 
-    public ConstrainedValueParameter<StringValue> AppendModeParameter {
-      get { return (ConstrainedValueParameter<StringValue>) Parameters["AppendMode"]; }
-    } 
+      get { return (ValueParameter<StringValue>)Parameters["ZipFileName"]; }
+    }
+    public IConstrainedValueParameter<StringValue> AppendModeParameter {
+      get { return (IConstrainedValueParameter<StringValue>)Parameters["AppendMode"]; }
+    }
     #endregion
 
@@ -51,5 +49,5 @@
     protected int Padding { get { return PaddingParameter.Value.Value; } }
     protected AppendModes AppendMode { get { return (AppendModes)Enum.Parse(typeof(AppendModes), AppendModeParameter.Value.Value); } }
-      protected List<IBoxChartElementGenerator> Generators {
+    protected List<IBoxChartElementGenerator> Generators {
       get {
         return ElementsParameter.Value.CheckedItems.Select(i => i.Value).ToList();
@@ -61,5 +59,6 @@
     [StorableConstructor]
     protected BoxChartCreator(bool deserializing) : base(deserializing) { }
-    protected BoxChartCreator(BoxChartCreator original, Cloner cloner) : base(original, cloner) {
+    protected BoxChartCreator(BoxChartCreator original, Cloner cloner)
+      : base(original, cloner) {
       RegisterEvents();
     }
@@ -67,9 +66,9 @@
       Parameters.Add(new ValueParameter<StringValue>("ChartName", "The result name of the chart.", new StringValue("Chart")));
       Parameters.Add(new ValueParameter<CheckedItemList<IBoxChartElementGenerator>>("Elements", "List of patient chart element generators.", new CheckedItemList<IBoxChartElementGenerator>()));
-      Parameters.Add(new ValueParameter<IntValue>("Size", "The size of one box in pixels.", new IntValue(50))); 
-      Parameters.Add(new ValueParameter<IntValue>("Padding", "The padding inside the boxes", new IntValue(1))); 
+      Parameters.Add(new ValueParameter<IntValue>("Size", "The size of one box in pixels.", new IntValue(50)));
+      Parameters.Add(new ValueParameter<IntValue>("Padding", "The padding inside the boxes", new IntValue(1)));
       Parameters.Add(new ValueParameter<StringValue>("ZipFileName", "The name of the zip file that will contain all generated charts.", new StringValue("")));
       Parameters.Add(new ConstrainedValueParameter<StringValue>("AppendMode", "Determines how coordinates of new elements are calculated.",
-        new ItemSet<StringValue>(Enum.GetNames(typeof (AppendModes)).Select(v => new StringValue(v)))));
+        new ItemSet<StringValue>(Enum.GetNames(typeof(AppendModes)).Select(v => new StringValue(v)))));
       AppendModeParameter.Value = AppendModeParameter.ValidValues.SingleOrDefault(v => v.Value == AppendModes.Horizontal.ToString());
       RegisterEvents();
@@ -84,5 +83,5 @@
       if (!Parameters.ContainsKey("AppendMode")) {
         Parameters.Add(new ConstrainedValueParameter<StringValue>("AppendMode", "Determines how coordinates of new elements are calculated.",
-          new ItemSet<StringValue>(Enum.GetNames(typeof (AppendModes)).Select(v => new StringValue(v)))));
+          new ItemSet<StringValue>(Enum.GetNames(typeof(AppendModes)).Select(v => new StringValue(v)))));
         AppendModeParameter.Value = AppendModeParameter.ValidValues.SingleOrDefault(v => v.Value == AppendModes.Horizontal.ToString());
       }
@@ -109,5 +108,5 @@
         var newItems = e.Items.Select(kvp => kvp.Value).ToList();
         switch (AppendMode) {
-          case AppendModes.Horizontal: 
+          case AppendModes.Horizontal:
             foreach (var generator in newItems) {
               generator.Y = generators.Max(g => g.Y + g.RowSpan - 1);
@@ -132,11 +131,11 @@
       var maxX = generators.Max(g => g.X + g.ColSpan);
       var maxY = generators.Max(g => g.Y + g.RowSpan);
-      for (int i = 0; i<runs.Count; i++) {
+      for (int i = 0; i < runs.Count; i++) {
         var run = runs[i];
-        var b = new Bitmap(maxX*Size, maxY*Size);
+        var b = new Bitmap(maxX * Size, maxY * Size);
         using (var g = Graphics.FromImage(b)) {
           g.FillRectangle(SystemBrushes.Control, 0, 0, b.Width, b.Height);
           foreach (var gen in generators) {
-            g.SetClip(new Rectangle(gen.X*Size+Padding, gen.Y*Size+Padding, gen.ColSpan*Size-2*Padding, gen.RowSpan*Size-2*Padding));
+            g.SetClip(new Rectangle(gen.X * Size + Padding, gen.Y * Size + Padding, gen.ColSpan * Size - 2 * Padding, gen.RowSpan * Size - 2 * Padding));
             gen.Draw(run, g);
             g.ResetClip();
Index: branches/FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/NeutralSelector.cs
===================================================================
--- branches/FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/NeutralSelector.cs	(revision 8083)
+++ branches/FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/NeutralSelector.cs	(revision 8172)
@@ -1,15 +1,14 @@
-﻿using System.Collections.Generic;
+﻿using System;
+using System.Collections.Generic;
 using System.Linq;
+using HeuristicLab.Analysis.FitnessLandscape.DistanceCalculators;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Operators;
 using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Selection;
 using HeuristicLab.PluginInfrastructure;
-using HeuristicLab.Operators;
-using System;
-using HeuristicLab.Analysis.FitnessLandscape.DistanceCalculators;
 
 namespace HeuristicLab.Analysis.FitnessLandscape {
@@ -50,6 +49,6 @@
       get { return (ILookupParameter<ItemArray<IItem>>)Parameters["Solution"]; }
     }
-    public ConstrainedValueParameter<IItemDistanceCalculator> SolutionDistanceCalculatorParameter {
-      get { return (ConstrainedValueParameter<IItemDistanceCalculator>)Parameters["SolutionDistanceCalculator"]; }
+    public IConstrainedValueParameter<IItemDistanceCalculator> SolutionDistanceCalculatorParameter {
+      get { return (IConstrainedValueParameter<IItemDistanceCalculator>)Parameters["SolutionDistanceCalculator"]; }
     }
     public ValueLookupParameter<DoubleValue> EpsilonParameter {
@@ -57,6 +56,6 @@
     }
     public ILookupParameter<DoubleValue> CurrentFractionOfNeutralNeighborsParameter {
-      get { return (LookupParameter<DoubleValue>) Parameters["CurrentFractionOfNeutralNeighbors"]; }
-    } 
+      get { return (LookupParameter<DoubleValue>)Parameters["CurrentFractionOfNeutralNeighbors"]; }
+    }
     public LookupParameter<DoubleValue> CurrentNeutralDistanceParameter {
       get { return (LookupParameter<DoubleValue>)Parameters["CurrentNeutralDistance"]; }
@@ -78,9 +77,9 @@
       set {
         if (CurrentNeutralDistanceParameter.ActualValue == null)
-          CurrentNeutralDistanceParameter.ActualValue= new DoubleValue(value);
-        else 
+          CurrentNeutralDistanceParameter.ActualValue = new DoubleValue(value);
+        else
           CurrentNeutralDistanceParameter.ActualValue.Value = value;
       }
-      
+
     }
     protected double CurrentFractionOfNeutralNeighbors {
@@ -165,11 +164,11 @@
 
       var neighbors = QualityParameter.ActualValue
-        .Zip(items, (q, i) => new { Quality=q.Value, Item=i })
+        .Zip(items, (q, i) => new { Quality = q.Value, Item = i })
         .Select((p, i) => new {
-          Idx=i,
-          Diff=Squash(Math.Abs(baseQuality-p.Quality), eps),
-          StartDist=calc.Distance(startingPoint, p.Item),
-          BaseDist=calc.Distance(baseSolution, p.Item)
-        })        
+          Idx = i,
+          Diff = Squash(Math.Abs(baseQuality - p.Quality), eps),
+          StartDist = calc.Distance(startingPoint, p.Item),
+          BaseDist = calc.Distance(baseSolution, p.Item)
+        })
         .Where(n => n.BaseDist > 0)
         .ToList();
@@ -181,5 +180,5 @@
         if (mostDistantNeutralNeighbor != null && mostDistantNeutralNeighbor.StartDist > currentNeutralDistance) {
           if (currentNeutralDistance == 0) {
-            StartingPointParameter.ActualValue = (IItem) baseSolution.Clone();
+            StartingPointParameter.ActualValue = (IItem)baseSolution.Clone();
             CurrentNeutralDistance = mostDistantNeutralNeighbor.BaseDist;
           } else {
@@ -199,8 +198,8 @@
           CurrentNeutralDistance = 0;
         }
-        CurrentFractionOfNeutralNeighbors = 1.0*neighbors.Count(n => n.Diff == 0)/neighbors.Count;
+        CurrentFractionOfNeutralNeighbors = 1.0 * neighbors.Count(n => n.Diff == 0) / neighbors.Count;
       }
       return base.Apply();
-    }    
+    }
 
     private void Select(int i) {
Index: branches/FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/PopDist/PopulationDistributionAnalyzer.cs
===================================================================
--- branches/FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/PopDist/PopulationDistributionAnalyzer.cs	(revision 8083)
+++ branches/FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/PopDist/PopulationDistributionAnalyzer.cs	(revision 8172)
@@ -66,6 +66,6 @@
       get { return (OptionalValueParameter<StringValue>)Parameters["Population Log File Name"]; }
     }
-    public ConstrainedValueParameter<IntValue> NQuantilesParameter {
-      get { return (ConstrainedValueParameter<IntValue>)Parameters["NQuantiles"]; }
+    public IConstrainedValueParameter<IntValue> NQuantilesParameter {
+      get { return (IConstrainedValueParameter<IntValue>)Parameters["NQuantiles"]; }
     }
     #endregion
Index: branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK/InteractionInitializers/SortedRandomInteractionsInitializer.cs
===================================================================
--- branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK/InteractionInitializers/SortedRandomInteractionsInitializer.cs	(revision 8083)
+++ branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK/InteractionInitializers/SortedRandomInteractionsInitializer.cs	(revision 8172)
@@ -1,12 +1,9 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
+﻿using System.Linq;
+using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Data;
-using HeuristicLab.Common;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Encodings.BinaryVectorEncoding;
 using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.PluginInfrastructure;
 
@@ -17,6 +14,6 @@
   public class SortedRandomInteractionsInitializer : ParameterizedNamedItem, IInteractionInitializer {
 
-    public ConstrainedValueParameter<IBinaryVectorComparer> ComparerParameter {
-      get { return (ConstrainedValueParameter<IBinaryVectorComparer>)Parameters["Comparer"]; }
+    public IConstrainedValueParameter<IBinaryVectorComparer> ComparerParameter {
+      get { return (IConstrainedValueParameter<IBinaryVectorComparer>)Parameters["Comparer"]; }
     }
 
@@ -24,5 +21,5 @@
       get { return ComparerParameter.Value; }
     }
-    
+
     [StorableConstructor]
     protected SortedRandomInteractionsInitializer(bool serializing) : base(serializing) { }
@@ -47,5 +44,6 @@
       try {
         IBinaryVectorComparer comparer = Comparer;
-      } catch {
+      }
+      catch {
         Parameters.Remove("Comparer");
         AddComparerParameter();
@@ -60,5 +58,5 @@
         if (indices.Count > c) {
           indices.RemoveAt(c);
-          components[c][c] = true;          
+          components[c][c] = true;
         }
         while (indices.Count > nInteractions) {
@@ -66,12 +64,12 @@
         }
         foreach (var i in indices) {
-          components[c][i] = true;          
+          components[c][i] = true;
         }
       }
       BoolMatrix m = new BoolMatrix(length, nComponents);
-      foreach (var c in components.OrderBy(v => v, Comparer).Select((v, j) => new {v, j})) {
-        for (int i = 0; i<c.v.Length; i++) {
+      foreach (var c in components.OrderBy(v => v, Comparer).Select((v, j) => new { v, j })) {
+        for (int i = 0; i < c.v.Length; i++) {
           m[i, c.j] = c.v[i];
-        }    
+        }
       }
       return m;
Index: branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK/NKLandscape.cs
===================================================================
--- branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK/NKLandscape.cs	(revision 8083)
+++ branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK/NKLandscape.cs	(revision 8172)
@@ -41,9 +41,9 @@
       get { return (ValueParameter<DoubleArray>)Parameters["Weights"]; }
     }
-    public OptionalConstrainedValueParameter<IInteractionInitializer> InteractionInitializerParameter {
-      get { return (OptionalConstrainedValueParameter<IInteractionInitializer>)Parameters["InteractionInitializer"]; }
-    }
-    public OptionalConstrainedValueParameter<IWeightsInitializer> WeightsInitializerParameter {
-      get { return (OptionalConstrainedValueParameter<IWeightsInitializer>)Parameters["WeightsInitializer"]; }
+    public IConstrainedValueParameter<IInteractionInitializer> InteractionInitializerParameter {
+      get { return (IConstrainedValueParameter<IInteractionInitializer>)Parameters["InteractionInitializer"]; }
+    }
+    public IConstrainedValueParameter<IWeightsInitializer> WeightsInitializerParameter {
+      get { return (IConstrainedValueParameter<IWeightsInitializer>)Parameters["WeightsInitializer"]; }
     }
     #endregion
@@ -60,7 +60,7 @@
     private List<IOperator> operators {
       set {
-       Operators.AddRange(value);
-      }
-    } 
+        Operators.AddRange(value);
+      }
+    }
     #endregion
 