Index: trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/BoundedIntegerVectorCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/BoundedIntegerVectorCrossover.cs	(revision 8183)
+++ trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/BoundedIntegerVectorCrossover.cs	(revision 8184)
@@ -50,14 +50,4 @@
 
     protected abstract IntegerVector CrossBounded(IRandom random, ItemArray<IntegerVector> parents, IntMatrix bounds);
-
-    protected static int RoundFeasible(int min, int max, int step, double value) {
-      return Math.Max(min, Math.Min(max, (int)Math.Round((value - min) / (double)step) * step + min));
-    }
-    protected static int FloorFeasible(int min, int max, int step, double value) {
-      return Math.Max(min, Math.Min(max, (int)Math.Floor((value - min) / (double)step) * step + min));
-    }
-    protected static int CeilingFeasible(int min, int max, int step, double value) {
-      return Math.Max(min, Math.Min(max, (int)Math.Ceiling((value - min) / (double)step) * step + min));
-    }
   }
 }
Index: trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/BoundedIntegerVectorManipulator.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/BoundedIntegerVectorManipulator.cs	(revision 8183)
+++ trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/BoundedIntegerVectorManipulator.cs	(revision 8184)
@@ -31,5 +31,5 @@
   [StorableClass]
   public abstract class BoundedIntegerVectorManipulator : IntegerVectorManipulator, IBoundedIntegerVectorOperator {
-    
+
     public IValueLookupParameter<IntMatrix> BoundsParameter {
       get { return (IValueLookupParameter<IntMatrix>)Parameters["Bounds"]; }
@@ -45,19 +45,9 @@
 
     protected sealed override void Manipulate(IRandom random, IntegerVector integerVector) {
-      if (BoundsParameter.ActualValue == null) throw new InvalidOperationException("UniformSomePositionsManipulator: Parameter " + BoundsParameter.ActualName + " could not be found.");
+      if (BoundsParameter.ActualValue == null) throw new InvalidOperationException("BoundedIntegerVectorManipulator: Parameter " + BoundsParameter.ActualName + " could not be found.");
       ManipulateBounded(random, integerVector, BoundsParameter.ActualValue);
     }
 
     protected abstract void ManipulateBounded(IRandom random, IntegerVector integerVector, IntMatrix bounds);
-
-    protected static int RoundFeasible(int min, int max, int step, double value) {
-      return Math.Max(min, Math.Min(max, (int)Math.Round((value - min) / (double)step) * step + min));
-    }
-    protected static int FloorFeasible(int min, int max, int step, double value) {
-      return Math.Max(min, Math.Min(max, (int)Math.Floor((value - min) / (double)step) * step + min));
-    }
-    protected static int CeilingFeasible(int min, int max, int step, double value) {
-      return Math.Max(min, Math.Min(max, (int)Math.Ceiling((value - min) / (double)step) * step + min));
-    }
   }
 }
Index: trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/Creators/UniformRandomIntegerVectorCreator.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/Creators/UniformRandomIntegerVectorCreator.cs	(revision 8183)
+++ trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/Creators/UniformRandomIntegerVectorCreator.cs	(revision 8184)
@@ -46,6 +46,6 @@
     /// <param name="random">The random number generator.</param>
     /// <param name="length">The length of the int vector.</param>
-    /// <param name="min">The minimum value of the sampling range for each vector element (inclusive).</param>
-    /// <param name="max">The maximum value of the sampling range for each vector element (exclusive).</param>
+    /// <param name="bounds">A matrix containing the inclusive lower and inclusive upper bound in the first and second column and a step size in the third column.
+    /// Each line represents the bounds for a certain dimension. If fewer lines are given, the lines are cycled.</param>
     /// <returns>The newly created integer vector.</returns>
     public static IntegerVector Apply(IRandom random, int length, IntMatrix bounds) {
Index: trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/HeuristicLab.Encodings.IntegerVectorEncoding-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/HeuristicLab.Encodings.IntegerVectorEncoding-3.3.csproj	(revision 8183)
+++ trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/HeuristicLab.Encodings.IntegerVectorEncoding-3.3.csproj	(revision 8184)
@@ -122,4 +122,5 @@
     </Compile>
     <Compile Include="Crossovers\RoundedUniformArithmeticCrossover.cs" />
+    <Compile Include="IntegerVectorOperator.cs" />
     <Compile Include="Interfaces\IBoundedIntegerVectorOperator.cs" />
     <Compile Include="Interfaces\IIntegerVectorCreator.cs" />
Index: trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorCrossover.cs	(revision 8183)
+++ trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorCrossover.cs	(revision 8184)
@@ -22,5 +22,4 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Operators;
 using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
@@ -33,5 +32,5 @@
   [Item("IntegerVectorCrossover", "A base class for operators that perform a crossover of int-valued vectors.")]
   [StorableClass]
-  public abstract class IntegerVectorCrossover : SingleSuccessorOperator, IIntegerVectorCrossover, IStochasticOperator {
+  public abstract class IntegerVectorCrossover : IntegerVectorOperator, IIntegerVectorCrossover, IStochasticOperator {
     public override bool CanChangeName {
       get { return false; }
Index: trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorManipulator.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorManipulator.cs	(revision 8183)
+++ trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorManipulator.cs	(revision 8184)
@@ -22,5 +22,4 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Operators;
 using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
@@ -33,5 +32,5 @@
   [Item("IntegerVectorManipulator", "A base class for operators that manipulate int-valued vectors.")]
   [StorableClass]
-  public abstract class IntegerVectorManipulator : SingleSuccessorOperator, IIntegerVectorManipulator, IStochasticOperator {
+  public abstract class IntegerVectorManipulator : IntegerVectorOperator, IIntegerVectorManipulator, IStochasticOperator {
     public override bool CanChangeName {
       get { return false; }
Index: trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorOperator.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorOperator.cs	(revision 8184)
+++ trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorOperator.cs	(revision 8184)
@@ -0,0 +1,48 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Operators;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.IntegerVectorEncoding {
+  [Item("IntegerVectorOperator", "Base class for integer vectoro operators.")]
+  [StorableClass]
+  public abstract class IntegerVectorOperator : SingleSuccessorOperator, IIntegerVectorOperator {
+
+    [StorableConstructor]
+    protected IntegerVectorOperator(bool deserializing) : base(deserializing) { }
+    protected IntegerVectorOperator(IntegerVectorOperator original, Cloner cloner) : base(original, cloner) { }
+    public IntegerVectorOperator() : base() { }
+
+    public static int RoundFeasible(int min, int max, int step, double value) {
+      return Math.Max(min, Math.Min(max, (int)Math.Round((value - min) / (double)step) * step + min));
+    }
+    public static int FloorFeasible(int min, int max, int step, double value) {
+      return Math.Max(min, Math.Min(max, (int)Math.Floor((value - min) / (double)step) * step + min));
+    }
+    public static int CeilingFeasible(int min, int max, int step, double value) {
+      return Math.Max(min, Math.Min(max, (int)Math.Ceiling((value - min) / (double)step) * step + min));
+    }
+  }
+}